=== debian/changelog ===
gromacs (5.1.2-1ubuntu1) xenial; urgency=medium

  * Limit parallel build to 2 jobs for amd64 to avoid FTBFS while building
    doxygen documentation on Ubuntu buildds.

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 05 Apr 2016 22:41:20 +0200

gromacs (5.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Add hppa, s390x, x32 to list of architectures for gromacs-openmpi.
    In turn, increase required version of libopenmpi-dev to >= 1.10.2-7.
  * Add new patches/reproducible-builds.patch for... reproducible builds.
    This is preliminary work and may not be complete.
  * doxygen.patch: work around FTBFS with doxygen >= 1.8.11 (no problems
    with previous 1.8.9).  (Closes: #815678)
  * spelling.patch: Additional fixes.
  * Update Standards-Version to 3.9.7, no changes required.

 -- Nicholas Breen <nbreen@debian.org>  Sun, 28 Feb 2016 13:31:21 -0800
